%%This is an attemot to create a model with is sensetive to differnet
%%temperatures

%load polynomials for 20, 30, 50, deg

load karstens_model_data_20deg
load karstens_model_data_30deg
load karstens_model_data_50deg

%Paprameters for plot vectors
%Temp = 20:5:50
Temp = [20    25    30   35   40   45   50]  %#ok<*NOPTS>
Templengh = numel(Temp)
SOC = linspace(0,1,100)

%Temperatur vector
T = [20; 30; 50]
Tc = [20; 30; 40;  50] % test for differnet C transitions

%% fits for c (changing point for both functions)

%C = [0.684; 0.725; 0.87 ;0.918] test for playing around with different C
%transitions
C = [0.684; 0.725 ;0.918]
c_fit = fit(T, C, 'linearinterp') 

figure(15)
plot(c_fit, T, C) 

%% OCV - high

for i = 1:6 % to number of polynomial values
    OCV_high_all(:,i) = [OCV_POLYhigh20(i) ; OCV_POLYhigh30(i) ; OCV_POLYhigh50(i)] %#ok<*SAGROW>
    OCV_high_fits{i} = fit(T, OCV_high_all(:,i), 'linearinterp' ) 
%     f_OCV_high_all(1,i) = fitting.p1
%     f_OCV_high_all(2,i) = fitting.p2
%     f_OCV_high_all(3,i) = fitting.p3
    figure(1)
    subplot(1,6,i)
    plot(OCV_high_fits{i}, T, OCV_high_all(:,i))
end

%Plotting the differnt Fitts
for t = 1:Templengh
    tempnow = Temp(t)
%for polynomial fitting
% for i = 1:6
%     OCV_POLYDATA_high(i) = polyval(coeffvalues(OCV_high_fits{i}), tempnow)
% end
%for linear pieceswise fit
for i = 1:6
    OCV_POLYDATA_high(i) = OCV_high_fits{i}(tempnow)
end

OCVhigh(t,:) = polyval(OCV_POLYDATA_high, SOC)

figure(2)
set(gcf,'Color',[1,1,1])
plot(SOC, OCVhigh(t,:), 'LineWidth',2 )
axis([0,1,0,2.5])
title('Function OCV high- test')
legend('20', '25', '30', '35','40','45', '50')
xlabel('SoC') % x-axis label
ylabel('Open Circuit Voltage [V]') % y-axis label

hold on

end
hold off 


%% OCV - low
for i = 1:9
    OCV_low_all(:,i) = [OCV_POLYlow20(i) ; OCV_POLYlow30(i) ; OCV_POLYlow50(i)]
    OCV_low_fits{i} = fit(T, OCV_low_all(:,i), 'linearinterp') 
    
    figure(3)
    subplot(1,9,i)
    plot(OCV_low_fits{i}, T, OCV_low_all(:,i)) 
end

% Plotting the differnt Fitts
for t = 1:Templengh
    tempnow = Temp(t)

% for i = 1:numel(OCV_low_fits)
%     OCV_POLYDATA_low(i) = polyval(coeffvalues(OCV_low_fits{i}), tempnow)
% end
%for linear pieceswise fit
for i = 1:numel(OCV_low_fits)
    OCV_POLYDATA_low(i) = OCV_low_fits{i}(tempnow)
end


%Streching the low polynomials for better fit
StrechFactors = [1; 1;  0.85; 0.85;  1]
Tempstrech = [20; 30; 35; 45; 50]
Streching_OCVlow = fit(Tempstrech, StrechFactors, 'linearinterp')
figure(33)
plot(Streching_OCVlow, Tempstrech, StrechFactors) 


%strech = [1 1 1 0.85 0.85 0.85 1 1]
%strech = [1 1 1 0.9 0.85 0.85 0.85 1]
strech = Streching_OCVlow(tempnow)


OCVlow(t,:) = polyval(OCV_POLYDATA_low, (SOC*strech))

figure(4)
set(gcf,'Color',[1,1,1])
plot(SOC, OCVlow(t,:), 'LineWidth',2 )
axis([0,1,0,2.5])
title('Function OCV low- test')
legend('20', '25', '30', '35','40','45', '50')
xlabel('SoC') % x-axis label
ylabel('Open Circuit Voltage [V]') % y-axis label
hold on 


end
hold off

%% Putting both together - OCV
    %test with manually chosen CC
    C_man =  [0.684; 0.71; 0.725 ;0.77 ;0.825; 0.88 ;0.918] ; % [0.684; 0.71; 0.725; 0.75 ;0.77 ;0.825; 0.88 ;0.918]
    C_fit = fit(Temp', C_man, 'linearinterp')
    figure(34)
    plot(C_fit, Temp', C_man) 
 
    
    
    
    %C_man = [0.684; 0.7045; 0.725; 0.86 ;0.89; 0.9 ;0.918]
    %C_man = [0.684000000000000;0.704500000000000;0.725000000000000;0.773250000000000;0.821500000000000;0.869750000000000;0.918000000000000]
for t = 1:Templengh
    tempnow = Temp(t)
    
    %CC = polyval(coeffvalues(c_fit), tempnow) %for polynomials 
    %CC = c_fit(tempnow) %for linearinterp
    CC = C_fit(tempnow)
    
    
    insin = 2*50*(SOC-CC)
    gamma1 = 0.5 + 0.5*sin(insin)

    test2(insin<-0.5*pi()) = 0
    test2(-0.5*pi()<=insin & insin<0.5*pi()) = gamma1(-0.5*pi()<=insin & insin<0.5*pi())
    test2(insin>0.5*pi()) = 1

    OCV_all(t,:) = (1-test2) .* OCVlow(t,:) + test2 .* OCVhigh(t,:)
    
    
    figure(50)
    set(gcf,'Color',[1,1,1])
    subplot(4,1,1)
    plot(SOC, OCV_all(t,:), 'LineWidth',2 )
    axis([0,1,2.065,2.45])
    title('Function OCV all- test')
    legend('20', '25', '30', '35','40','45', '50')
    xlabel('SoC') % x-axis label
    ylabel('Open Circuit Voltage [V]') % y-axis label
    hold on 
end
    hold off

        
% %% Check if the rounded polynomials for 20 and 50 deg work for OCV
% 
% CC_20 = 0.684
% CC_30 = 0.71
% CC_50 = 0.918
% 
% %20 deg
% OCV_POLYhigh_paper20 = round(OCV_POLYhigh20,2)
% OCV_POLYlow_paper20 = round(OCV_POLYlow20,2)
% 
% OCVhigh_paper20 = polyval(OCV_POLYhigh_paper20, SOC)
% OCVlow_paper20 = polyval(OCV_POLYlow_paper20, SOC)
% 
%     insin_20 = 2*50*(SOC-CC_20)
%     gamma1_20 = 0.5 + 0.5*sin(insin_20)
% 
%     test2_20(insin_20<-0.5*pi()) = 0
%     test2_20(-0.5*pi()<=insin_20 & insin_20<0.5*pi()) = gamma1_20(-0.5*pi()<=insin_20 & insin_20<0.5*pi())
%     test2_20(insin_20>0.5*pi()) = 1
% 
% 
% OCV_all_paper20 = (1-test2_20) .* OCVlow_paper20 + test2_20 .* OCVhigh_paper20
% 
% 
% %20 deg
% OCV_POLYhigh_paper20 = round(OCV_POLYhigh20,2)
% OCV_POLYlow_paper20 = round(OCV_POLYlow20,2)
% 
% OCVhigh_paper20 = polyval(OCV_POLYhigh_paper20, SOC)
% OCVlow_paper20 = polyval(OCV_POLYlow_paper20, SOC)
% 
%     insin_20 = 2*50*(SOC-CC_20)
%     gamma1_20 = 0.5 + 0.5*sin(insin_20)
% 
%     test2_20(insin_20<-0.5*pi()) = 0
%     test2_20(-0.5*pi()<=insin_20 & insin_20<0.5*pi()) = gamma1_20(-0.5*pi()<=insin_20 & insin_20<0.5*pi())
%     test2_20(insin_20>0.5*pi()) = 1
% 
% 
% OCV_all_paper20 = (1-test2_20) .* OCVlow_paper20 + test2_20 .* OCVhigh_paper20
% 
% 
% %30 deg
% OCV_POLYhigh_paper30 = round(OCV_POLYhigh30,2)
% OCV_POLYlow_paper30 = round(OCV_POLYlow30,2)
% 
% OCVhigh_paper30 = polyval(OCV_POLYhigh_paper30, SOC)
% OCVlow_paper30 = polyval(OCV_POLYlow_paper30, SOC)
% 
%     insin_30 = 2*50*(SOC-CC_30)
%     gamma1_30 = 0.5 + 0.5*sin(insin_30)
% 
%     test2_30(insin_30<-0.5*pi()) = 0
%     test2_30(-0.5*pi()<=insin_30 & insin_30<0.5*pi()) = gamma1_30(-0.5*pi()<=insin_30 & insin_30<0.5*pi())
%     test2_30(insin_30>0.5*pi()) = 1
% 
% OCV_all_paper30 = (1-test2_30) .* OCVlow_paper30 + test2_30 .* OCVhigh_paper30
% 
% 
% figure(30)
%     set(gcf,'Color',[1,1,1])
%     plot(SOC, OCV_all(1,:), SOC, OCV_all(7,:), SOC, OCV_all(3,:),  SOC, OCV_all_paper20, SOC, OCV_all_paper50, SOC, OCV_all_paper30, 'LineWidth',2 ) %OCV_all(1,:) is the first temperature: 20deg OCV_all(7,is th elast temp)
%     axis([0,1,0,2.5])
%     title('Function OCV all- test')
%     legend('20', '50', '30','paper 20', 'paper 50', 'paper 30')
%     xlabel('SoC') % x-axis label
%     ylabel('Open Circuit Voltage [V]') % y-axis label
%----------------------------------------------------------------------------------------------- 


%% Ri - high
for i = 1:7
    Ri_high_all(:,i) = [Ri_POLYhigh20(i) ; Ri_POLYhigh30(i) ; Ri_POLYhigh50(i)]
    Ri_high_fits{i} = fit(T, Ri_high_all(:,i), 'linearinterp') 
    
    figure(6)
    subplot(1,7,i)
    plot(Ri_high_fits{i}, T, Ri_high_all(:,i)) 
end

% Plotting the differnt Fitts
for t = 1:Templengh
    tempnow = Temp(t)

% for i = 1:numel(Ri_high_fits)
%     Ri_high_POLYDATA(i) = polyval(coeffvalues(Ri_high_fits{i}), tempnow)
% end
%for linear pieceswise fit
for i = 1:numel(Ri_high_fits)
    Ri_high_POLYDATA(i) = Ri_high_fits{i}(tempnow)
end



Ri_high(t,:) = polyval(Ri_high_POLYDATA, SOC)

figure(7)
set(gcf,'Color',[1,1,1])
plot(SOC, Ri_high(t,:), 'LineWidth',2 )
axis([0,1,0,0.2])
title('Function Ri high- test')
legend('20', '25', '30', '35','40','45', '50')
xlabel('SoC') % x-axis label
ylabel('Open Circuit Voltage [V]') % y-axis label
hold on 


end
hold off



%% Ri - low

for i = 1:7
    Ri_low_all(:,i) = [Ri_POLYlow20(i) ; Ri_POLYlow30(i) ; Ri_POLYlow50(i)]
    Ri_low_fits{i} = fit(T, Ri_low_all(:,i), 'linearinterp') 
    
    figure(8)
    subplot(1,7,i)
    plot(Ri_low_fits{i}, T, Ri_low_all(:,i)) 
end

% Plotting the differnt Fitts
for t = 1:Templengh
    tempnow = Temp(t)

% for i = 1:numel(Ri_low_fits)
%     Ri_low_POLYDATA(i) = polyval(coeffvalues(Ri_low_fits{i}), tempnow)
% end
%for linear pieceswise fit
for i = 1:numel(Ri_low_fits)
    Ri_low_POLYDATA(i) = Ri_low_fits{i}(tempnow)
end


strech = Streching_OCVlow(tempnow)
Ri_low(t,:) = polyval(Ri_low_POLYDATA, (SOC*strech))

figure(9)
set(gcf,'Color',[1,1,1])
plot(SOC, Ri_low(t,:), 'LineWidth',2 )
axis([0,1,0,0.2])
title('Function Rint low- test')
legend('20', '25', '30', '35','40','45', '50')
xlabel('SoC') % x-axis label
ylabel('Open Circuit Voltage [V]') % y-axis label
hold on 

end
hold off


%% Putting both together - Ri
for t = 1:Templengh
    tempnow = Temp(t)
    
    %CC = polyval(coeffvalues(c_fit), tempnow) %for polynomials
    %CC = c_fit(tempnow) %for linearinterp

    CC = C_fit(tempnow) %manually adjusted C values
    
    insin = 2*50*(SOC-CC)
    gamma1 = 0.5 + 0.5*sin(insin)

    test2(insin<-0.5*pi()) = 0
    test2(-0.5*pi()<=insin & insin<0.5*pi()) = gamma1(-0.5*pi()<=insin & insin<0.5*pi())
    test2(insin>0.5*pi()) = 1

    Ri_all(t,:) = (1-test2) .* Ri_low(t,:) + test2 .* Ri_high(t,:)
    
    
    figure(50)
    subplot(4,1,2)
    plot(SOC, Ri_all(t,:), 'LineWidth',2 )
    axis([0,1,0,0.18])
    title('Function Rint- test')
    legend('20', '25', '30', '35','40','45', '50')
    xlabel('SoC') % x-axis label
    ylabel('Open Circuit Voltage [V]') % y-axis label
    hold on 
end
    hold off
    
% %% Check if the rounded polynomials for 20 and 50 deg work for RI
% 
% CC_20 = 0.684
% CC_30 = 0.73
% CC_50 = 0.918
% 
% %20 deg
% Ri_POLYhigh_paper20 = round(Ri_POLYhigh20,2)
% Ri_POLYlow_paper20 = round(Ri_POLYlow20,2)
% 
% Rihigh_paper20 = polyval(Ri_POLYhigh_paper20, SOC)
% Rilow_paper20 = polyval(Ri_POLYlow_paper20, SOC)
% 
%     insin_20 = 2*50*(SOC-CC_20)
%     gamma1_20 = 0.5 + 0.5*sin(insin_20)
% 
%     test2_20(insin_20<-0.5*pi()) = 0
%     test2_20(-0.5*pi()<=insin_20 & insin_20<0.5*pi()) = gamma1_20(-0.5*pi()<=insin_20 & insin_20<0.5*pi())
%     test2_20(insin_20>0.5*pi()) = 1
% 
% 
% test3_paper20 = (1-test2_20) .* Rilow_paper20 + test2_20 .* Rihigh_paper20
% 
% 
% %30 deg
% Ri_POLYhigh_paper30 = round(Ri_POLYhigh30,2)
% Ri_POLYlow_paper30 = round(Ri_POLYlow30,2)
% 
% Rihigh_paper30 = polyval(Ri_POLYhigh_paper30, SOC)
% Rilow_paper30 = polyval(Ri_POLYlow_paper30, SOC)
% 
%     insin_30 = 2*50*(SOC-CC_30)
%     gamma1_30 = 0.5 + 0.5*sin(insin_30)
% 
%     test2_30(insin_30<-0.5*pi()) = 0
%     test2_30(-0.5*pi()<=insin_30 & insin_30<0.5*pi()) = gamma1_30(-0.5*pi()<=insin_30 & insin_30<0.5*pi())
%     test2_30(insin_30>0.5*pi()) = 1
% 
% 
% test3_paper30 = (1-test2_30) .* Rilow_paper30 + test2_30 .* Rihigh_paper30
% 
% %50 deg
% Ri_POLYhigh_paper50 = round(Ri_POLYhigh50,2)
% Ri_POLYlow_paper50 = round(Ri_POLYlow50,3)
% 
% Rihigh_paper50 = polyval(Ri_POLYhigh_paper50, SOC)
% Rilow_paper50 = polyval(Ri_POLYlow_paper50, SOC)
% 
%     insin_50 = 2*50*(SOC-CC_50)
%     gamma1_50 = 0.5 + 0.5*sin(insin_50)
% 
%     test2_50(insin_50<-0.5*pi()) = 0
%     test2_50(-0.5*pi()<=insin_50 & insin_50<0.5*pi()) = gamma1_50(-0.5*pi()<=insin_50 & insin_50<0.5*pi())
%     test2_50(insin_50>0.5*pi()) = 1
% 
% test3_paper50 = (1-test2_50) .* Rilow_paper50 + test2_50 .* Rihigh_paper50
% 
% 
% figure(30)
%     set(gcf,'Color',[1,1,1])
%     plot(SOC, Ri_all(1,:), SOC, Ri_all(7,:),SOC, Ri_all(3,:), SOC, test3_paper20, SOC, test3_paper50, SOC, test3_paper30, 'LineWidth',2 ) %test3(1,:) is the first temperature: 20deg test3(7,is th elast temp)
%     axis([0,1,0,2.5])
%     title('Function Ri all- test')
%     legend('20', '50', 'paper 20', 'paper 50')
%     xlabel('SoC') % x-axis label
%     ylabel('Open Circuit Voltage [V]') % y-axis label
% %----------------------------------------------------------------------------------------------------------------


%% R1
for i = 1:10
    R1_all(:,i) = [R1_SOC_POLY20(i) ; R1_SOC_POLY30(i) ; R1_SOC_POLY50(i)]
    R1_fits{i} = fit(T, R1_all(:,i), 'linearinterp') 
    
    figure(11)
    subplot(1,10,i)
    plot(R1_fits{i}, T, R1_all(:,i)) 
end

% Plotting the differnt Fitts
for t = 1:Templengh
    tempnow = Temp(t)

% %for polynomials
% for i = 1:numel(R1_fits)
%     R1_POLYDATA(i) = polyval(coeffvalues(R1_fits{i}), tempnow) 
% end
%for linearinterp
for i = 1:numel(R1_fits)
    R1_POLYDATA(i) = R1_fits{i}(tempnow) 
end

R1(t,:) = polyval(R1_POLYDATA, SOC)

figure(50)
subplot(4,1,3)
plot(SOC, R1(t,:), 'LineWidth',2 )
axis([0,1,0,0.155])
title('Function R1 all- test')
legend('20', '25', '30', '35','40','45', '50')
xlabel('SoC') % x-axis label
ylabel('Open Circuit Voltage [V]') % y-axis label
hold on 


end
hold off

%% C1
for i = 1:6
    C1_all(:,i) = [C1_SOC_POLY20(i) ; C1_SOC_POLY30(i) ; C1_SOC_POLY50(i)]
    C1_fits{i} = fit(T, C1_all(:,i), 'linearinterp') 
    
    figure(13)
    subplot(1,6,i)
    plot(C1_fits{i}, T, C1_all(:,i)) 
end

% Plotting the differnt Fitts
for t = 1:Templengh
    tempnow = Temp(t)

% %for ploynomial values
% for i = 1:numel(C1_fits)
%     C1_POLYDATA(i) = polyval(coeffvalues(C1_fits{i}), tempnow)
% end
%for linearinterp
for i = 1:numel(C1_fits)
    C1_POLYDATA(i) = C1_fits{i}(tempnow) 
end

C1(t,:) = polyval(C1_POLYDATA, SOC)

figure(50)
subplot(4,1,4)
plot(SOC, C1(t,:), 'LineWidth',2 )
axis([0,1,0,20000])
title('Function C1 all- test')
legend('20', '25', '30', '35','40','45', '50')
xlabel('SoC') % x-axis label
ylabel('Open Circuit Voltage [V]') % y-axis label
hold on 


end
hold off



% % Check if the rounded polynomials for 20 and 50 deg work for Rp and Cp
% 
% 
% 
% %20 deg
% C1_SOC_POLY_paper20 = round(C1_SOC_POLY20,2)
% C1_SOC_POLY_paper50 = round(C1_SOC_POLY50,2)
% 
% R1_SOC_POLY_paper20 = round(R1_SOC_POLY20,3)
% R1_SOC_POLY_paper50 = round(R1_SOC_POLY50,2)
% 
% 
% 
% C1_paper20 = polyval(C1_SOC_POLY_paper20, SOC)
% C1_paper50 = polyval(C1_SOC_POLY_paper50, SOC)
% 
% R1_paper20 = polyval(R1_SOC_POLY_paper20, SOC)
% R1_paper50 = polyval(R1_SOC_POLY_paper50, SOC)
% 
% 
% 
% figure(30)
%     set(gcf,'Color',[1,1,1])
%     plot(SOC, C1(1,:), SOC, C1(7,:),SOC, C1_paper20, SOC, C1_paper50, 'LineWidth',1 ) %test3(1,:) is the first temperature: 20deg test3(7,is th elast temp)
%     %axis([0,1,0,2.5])
%     title('Function Ci all- test')
%     legend('C1 - 20', 'C1 - 50', 'pa - 20', 'pa -50')
%     xlabel('SoC') % x-axis label
%     ylabel('Open Circuit Voltage [V]') % y-axis label
%     
%  figure(31)
%     set(gcf,'Color',[1,1,1])
%     plot(SOC, R1(1,:), SOC, R1(7,:),SOC, R1_paper20, SOC, R1_paper50, 'LineWidth',1 ) %test3(1,:) is the first temperature: 20deg test3(7,is th elast temp)
%     %axis([0,1,0,2.5])
%     title('Function Ri all- test')
%     legend('R1 - 20', 'R1 - 50', 'pa - 20', 'pa -50')
%     xlabel('SoC') % x-axis label
%     ylabel('Open Circuit Voltage [V]') % y-axis label
% %----------------------------------------------------------------------------------------------------------------


%% Capacity 

Cap_all = [CELL_CAPACITY20; CELL_CAPACITY30; CELL_CAPACITY50]
f_Cap_all = fit(T, Cap_all, 'linearinterp') 
figure(2)
plot(f_Cap_all, T, Cap_all)


% %% Plot for Paper
% 
%  figure(51)
%     set(gcf,'Color',[1,1,1])
%     subplot(4,1,1)
%     plot(SOC, OCV_all(1,:), 'g-x'  , SOC, OCV_all(2,:), '--' , SOC, OCV_all(3,:), 'b-+' , SOC, OCV_all(4,:), '--' , SOC, OCV_all(5,:), '--' , SOC, OCV_all(6,:), '--' , SOC, OCV_all(7,:), 'k', 'LineWidth',1 )
%     %ax = plotyy(SOC, OCV_all(1,:), 'g-x'  , SOC, OCV_all(2,:), '--' , SOC, OCV_all(3,:), 'b-+' , SOC, OCV_all(4,:), '--' , SOC, OCV_all(5,:), '--' , SOC, OCV_all(6,:), '--' , SOC, OCV_all(7,:), 'k', 'LineWidth',1 )
%     set(gca, 'XDir', 'reverse')
%     axis([0,1,2.065,2.45])
%     title('Functions OCV')
%     legend( '20C', '25C', '30C', '35C','40C','45C', '50C')
%     ylabel('Open Circuit Voltage [V]') % y-axis label
%     
%     subplot(4,1,2)
%     plot(SOC, Ri_all(1,:), 'g-x'  , SOC, Ri_all(2,:), '--' , SOC, Ri_all(3,:), 'b-+' ,SOC, Ri_all(4,:),'--' ,SOC, Ri_all(5,:), '--' ,SOC, Ri_all(6,:), '--' ,SOC ,  Ri_all(7,:), 'k','LineWidth',1 )
%     set(gca, 'XDir', 'reverse')
%     axis([0,1,0,0.18])
%     %set(gca, 'XTickLabelMode', 'manual', 'XTickLabel', []);
%     title('Functions R0')
%     legend( '20C', '25C', '30C', '35C','40C','45C', '50C')
%     ylabel('R0 [Ohm]')
%  
%     
%     subplot(4,1,3)
%     plot(SOC, R1(1,:), 'g-x'  , SOC, R1(2,:), '--' , SOC, R1(3,:), 'b-+' ,SOC, R1(4,:),'--' ,SOC, R1(5,:), '--' ,SOC, R1(6,:),'--' ,SOC, R1(7,:),'k','LineWidth',1 )
%     set(gca, 'XDir', 'reverse')
%     axis([0,1,0,0.13])
%     title('Functions Rp')
%     legend( '20C', '25C', '30C', '35C','40C','45C', '50C')
%     ylabel('Rp [Ohm]') % y-axis label
%     
%     
%     
%     subplot(4,1,4)
%     plot(SOC, C1(1,:), 'g-x'  , SOC, C1(2,:), '--' ,SOC, C1(3,:), 'b-+' ,SOC, C1(4,:), '--' ,SOC, C1(5,:), '--' ,SOC, C1(6,:), '--' ,SOC, C1(7,:),'k','LineWidth',1 )
%     set(gca, 'XDir', 'reverse')
%     axis([0,1,0,15000])
%     title('Functions Cp')
%     legend( '20C', '25C', '30C', '35C','40C','45C', '50C')
%     xlabel('SoC') % x-axis label
%     ylabel('Cp [F]') % y-axis label

